# generated by datamodel-codegen:
#   filename:  data_lab.json

from __future__ import annotations

from enum import Enum
from typing import Optional, Sequence, Union

from pydantic import BaseModel, Extra, Field, conint


class EnclaveSpecification(BaseModel):
    attestationProtoBase64: str
    id: str
    workerProtocol: conint(ge=0)


class FormatType(Enum):
    STRING = 'STRING'
    INTEGER = 'INTEGER'
    FLOAT = 'FLOAT'
    EMAIL = 'EMAIL'
    DATE_ISO8601 = 'DATE_ISO8601'
    PHONE_NUMBER_E164 = 'PHONE_NUMBER_E164'
    HASH_SHA256_HEX = 'HASH_SHA256_HEX'


class HashingAlgorithm(Enum):
    SHA256_HEX = 'SHA256_HEX'


class Type6(Enum):
    SUPPORTED = 'SUPPORTED'


class RequirementFlagValueItem6(BaseModel):
    type: Type6


class Type7(Enum):
    DATASET = 'DATASET'


class RequirementFlagValueItem7(BaseModel):
    type: Type7


class Type8(Enum):
    PROPERTY = 'PROPERTY'


class RequirementFlagValueItem8(BaseModel):
    type: Type8
    value: str


class RequirementFlagValue(BaseModel):
    __root__: Union[
        RequirementFlagValueItem6, RequirementFlagValueItem7, RequirementFlagValueItem8
    ]


class DataLabComputeV0(BaseModel):
    authenticationRootCertificatePem: str
    driverEnclaveSpecification: EnclaveSpecification
    id: str
    matchingIdFormat: FormatType
    matchingIdHashingAlgorithm: Optional[Optional[HashingAlgorithm]] = None
    name: str
    numEmbeddings: conint(ge=0)
    publisherEmail: str
    pythonEnclaveSpecification: EnclaveSpecification


class DataLabComputeV1(DataLabComputeV0):
    pass


class DataLabComputeV2(DataLabComputeV0):
    pass


class KnownOrUnknownRequirementFlagValue2(BaseModel):
    __root__: Optional[RequirementFlagValue]


class RequirementFlag2(BaseModel):
    details: KnownOrUnknownRequirementFlagValue2
    name: str


class Requirements(BaseModel):
    optional: Sequence[RequirementFlag2]
    required: Sequence[RequirementFlag2]


class DataLabComputeItem(BaseModel):
    class Config:
        extra = Extra.forbid

    v0: DataLabComputeV0


class DataLabComputeItem1(BaseModel):
    class Config:
        extra = Extra.forbid

    v1: DataLabComputeV1


class DataLabComputeItem2(BaseModel):
    class Config:
        extra = Extra.forbid

    v2: DataLabComputeV2


class DataLabCompute(BaseModel):
    __root__: Union[DataLabComputeItem, DataLabComputeItem1, DataLabComputeItem2]


class DataLabComputeOrUnknown(BaseModel):
    __root__: Optional[DataLabCompute]


class DataLabV0(BaseModel):
    compute: DataLabComputeOrUnknown
    features: Sequence[str]
    provides: Requirements


class DataLabItem(BaseModel):
    class Config:
        extra = Extra.forbid

    v0: DataLabV0


class DataLab(BaseModel):
    __root__: DataLabItem = Field(..., title='DataLab')
